import std.stdio;
import std.stream;
import std.string;
import std.math;
import Ccanvas;

uint RGB(uint r, uint g, uint b) {
  return ((r&0xff)<<16)|((g&0xff)<<8)|(b&0xff) ;
}


class Coloring
{
  uint[] img ;
  int    width, height ;
  int    step =10 ;
  int    phase= 0 ;
  
  this(){
  }
  
  int coloring(Ccanvas canvas){
    img.length=canvas.width*canvas.height ;
    for( int y=0 ; y<canvas.height ; y++ ){
      for( int x=0 ; x<canvas.width ; x++ ){
	int i=y*canvas.width+x ;
	if( canvas.array[y][x].count==-1 ){
	  img[i]=0 ;
	}else{
	  //      int r = cast(int)(255*pow(E,cast(real)(-canvas.array[i].count)/5.0)) ;
	  //      int g = 0 ; //cast(int)(255-255*pow(E,-(cast(real)(Z0.re)/10000.0))) ;
	  //      int b = 0 ; //cast(int)(255-255*pow(E,-(cast(real)(Z0.im)/10000.0))) ;
	  img[i]=HSVtoRGB(canvas.array[y][x].count*step+phase, 255, 255) ;
	}
      }
    }
    width  = canvas.width ;
    height = canvas.height ;
    return(0) ;
  }

  int setStep(int step){
    this.step=step ;
    return(0) ;
  }

  int getStep(){
    return(step) ;
  }

  int setPhase(int phase){
    this.phase=phase ;
    return(0) ;
  }

  int getPhase(){
    return(phase) ;
  }

  uint HSVtoRGB( int h, int s, int v){
    int v1,v2,v3,t,i ;
    int r,g,b ;

    h %= 256*6 ;
    if( s==0 ){
      r=v ; g=v ; b=v ;
    }else{
      i = h / 256 ;
      t = h % 256 ;
      v1=(v*((256-1)*256 - s*256    )+((256-1)*256/2))/((256-1)*256) ;
      v2=(v*((256-1)*256 - s*t      )+((256-1)*256/2))/((256-1)*256) ;
      v3=(v*((256-1)*256 - s*(256-t))+((256-1)*256/2))/((256-1)*256) ;
      switch( i ){
      case 0: r=v  ; g=v3 ; b=v1 ; break ;
      case 1: r=v2 ; g=v  ; b=v1 ; break ;
      case 2: r=v1 ; g=v  ; b=v3 ; break ;
      case 3: r=v1 ; g=v2 ; b=v  ; break ;
      case 4: r=v3 ; g=v1 ; b=v  ; break ;
      case 5: r=v  ; g=v1 ; b=v2 ; break ;
      default : break ;
      }
    }
    return( RGB(r,g,b) ) ;
  }
  
  uint[] getImage(){
    return(img) ;
  }
}
