import win32.windows;
import std.string;
import std.stdio;
import std.utf;
import win32frame.writek;
import win32frame.WindowObject ;

version(Win64){
  ushort HIWORD(ulong l){ return cast(WORD)(cast(DWORD_PTR)(l) >>> 16);}
  ushort LOWORD(ulong l){ return cast(WORD)(cast(DWORD_PTR)(l) & 0xffff); }
}else{
  ushort LOWORD(uint l){ return l & 0xffff; }
  ushort HIWORD(uint l){ return l >>> 16; }
}

class Launcher : WindowObject {
  WindowObject[] WOBJ_List ;
  bool initialized=false ;
  int  xnum, ynum   ;
  int  cellw, cellh ;
  int  addpos       ;
  bool autodiv      ;

  this(string name) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW ;
    this.setStyle(WS_CHILD | WS_TABSTOP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.lpszMenuName   = null;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_3DFACE)) ; //cast(HBRUSH)(GetStockObject(BLACK_BRUSH));
    winc.lpszClassName  = toUTFz!(wchar*)("Launcher") ;
    super(name) ;
    this.registwinc() ;
  }

  int initGrid(int xnum, int ynum, int width, int height, bool autodiv=false){
    if( initialized==true ) return(-2) ;
    if( xnum<=0 || ynum<=0 ) return(-1) ;
    if( autodiv==false && (width<=0 || height<=0) ) return(-1) ;
    this.xnum =xnum   ;
    this.ynum =ynum   ;
    this.cellw=width  ;
    this.cellh=height ;
    this.autodiv=autodiv ;
    WOBJ_List.length=xnum*ynum ;
    addpos=0 ;
    initialized=true ;
    return(0) ;
  }

  int addObject(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    int  ret=-1 ;
    if( addpos < WOBJ_List.length ){
      ret = WObj.create(this.getHWND(), hmenu) ;
      if( WObj.getHWND() != null ){
	WOBJ_List[addpos] = WObj ;
	int cw = cellw ;
	int ch = cellh ;
	if( autodiv==true ){
	  cw=winW/xnum ;
	  ch=winH/ynum ;
	}
	sendmsg( WM_SIZE, 0, (ch<<16 | cw) );
	addpos++ ;
      }
    }
    return( ret ) ;
  }

  int delObject(WindowObject WObj){
    return( 0 ) ;
  }

  int reDraw(){
    sendmsg(WM_SIZE, 0, (winH<<16 | winW) );
    return(0) ;
  }
    
  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE :
      break ;
      
    case WM_MOVE :
      winX=LOWORD(lp) ;
      winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      int px, py, cw, ch ;
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      
      py = 0 ;
      for( int y=0 ; y<ynum ; y++, py+=ch ){
	ch=(winH-py)/(ynum-y) ;
	px = 0 ;
	for( int x=0 ; x<xnum ; x++, px+=cw ){
	  cw=(winW-px)/(xnum-x) ;
	  if( autodiv!=true ){
	    cw = cellw ;
	    ch = cellh ;
	    px = x*cw  ;
	    py = y*ch  ;
	  }
	  if( WOBJ_List[y*xnum+x] !is null ){
	    MoveWindow( WOBJ_List[y*xnum+x].getHWND(), px, py, cw, ch, true ) ;
	  }
	}
      }
      break ;
      
    case WM_NOTIFY:
    case WM_HSCROLL:
    case WM_VSCROLL:
    case WM_COMMAND:
      sendmsgtoparent(msg, wp,lp) ;
      break ;
      
    default : break ;
    }
    
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }

}
